//+------------------------------------------------------------------+
//|                                               smHullSlope v4.mq4 |
//|                                            2009.07.01, SwingMan |
//|                                                                  |
//+------------------------------------------------------------------+
//mod param test mode
#property copyright " 2009.07.01, SwingMan"
#property link      ""

#property indicator_separate_window

#property indicator_buffers 6
#property indicator_color1 Maroon
#property indicator_color2 SlateGray
#property indicator_color3 Goldenrod
#property indicator_color4 Green
#property indicator_color5 OrangeRed
#property indicator_color6 Blue

#property indicator_width1 1 // histogram
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1 // zero line
#property indicator_width5 1
#property indicator_width6 1 // line


//#property indicator_level1 0

//---- inputs --------------------------------------------------------
extern int Avg_period= 27;
extern int smooth_period  = 5;
extern int smooth_method  = 1;
extern double treshold = 10;
//--------------------------------------------------------------------

double Line1[], Line2[];
double HullVector[], HullBuffer[];
double TrendUP[], TrendDN[];
double  HistoTr[], HistoRetr[];
//sigma[],
double Avg_periodDivisor = 1.5;
int Avg_method = MODE_LWMA;
int Avg_price  = PRICE_CLOSE;
int Avg_shift = 1;

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int init()
{
int iArrow = 158;//167;
//   ArraySetAsSeries(HullVector, true);
//   ArraySetAsSeries(HullBuffer, true);
//   ArraySetAsSeries(Line2, true);
   IndicatorBuffers(8);

   SetIndexBuffer(0,Line2);         SetIndexLabel(0,"sigma");     SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,HistoTr);       SetIndexLabel(1,"trend");     SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,HistoRetr);     SetIndexLabel(2,"retrace");   SetIndexStyle(2,DRAW_HISTOGRAM);   

   SetIndexBuffer(3,TrendUP);       SetIndexLabel(3,"sig UP");    SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,iArrow);
   SetIndexBuffer(4,TrendDN);       SetIndexLabel(4,"sig DN");    SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,iArrow);
      
   SetIndexBuffer(5,Line1);         SetIndexLabel(5,"slope");     SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(6,HullBuffer);    SetIndexBuffer(7,HullVector);

   IndicatorShortName("smHullSlope vX ("+Avg_period+") ");
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int deinit()
{
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
int start() 
{ 
//  ArrayResize(HullVector, Bars);
//  ArrayResize(HullBuffer, Bars);
//   ArrayResize(Line2, Bars);
   
string sSymbol = Symbol();
int iTF = Period();
int iTrend;
//int p = MathFloor(MathSqrt(Avg_period));
//int perVector = MathFloor(Avg_period/Avg_periodDivisor);   


   int HalfPeriod   = MathFloor(Avg_period/2);
   int HullPeriod   = MathFloor(MathSqrt(Avg_period));



   int counted_bars = IndicatorCounted();
   int i, limit;
   
   if (counted_bars < 0) return(-1);
   if (counted_bars > 0) counted_bars--;
   limit=Bars - counted_bars;
  
   //---- HULL vector
   for (i=limit;i>=0;i--)
      HullVector[i] = 2*iMA(sSymbol, iTF, HalfPeriod,0, Avg_method, Avg_price,i) -
                        iMA(sSymbol, iTF, Avg_period,0, Avg_method, Avg_price,i);
   
   //---- HULL buffer
   for (i=limit;i>=0;i--)
      HullBuffer[i] = iMAOnArray(HullVector, 0, HullPeriod, 0, Avg_method, i);
   
   //---- MAvg slope
   for (i=limit;i>=0;i--)
      if (HullBuffer[i+1] != 0)
         Line1[i] = 100*(HullBuffer[i] - HullBuffer[i+1]) / HullBuffer[i+1];
   for (i=limit;i>=0;i--)
   {        
   Line2[i] = iMAOnArray(Line1, 0, smooth_period, 0, smooth_method, i);
  
   
      //-- Trigger line
      
      double minVal = MathMin(Line1[i], Line2[i]);
      double maxVal = MathMax(Line1[i], Line2[i]);
      if (minVal != 0)
         double diffP = MathAbs(100 * (maxVal - minVal) / minVal);
         
            TrendUP[i] = EMPTY_VALUE; TrendDN[i] = EMPTY_VALUE;

      if (Line1[i]> Line2[i]) {
         if (diffP > treshold) {
            TrendUP[i] = 0;
            TrendDN[i] = EMPTY_VALUE;
         }
         else{
            TrendUP[i] = TrendUP[i+1];
            TrendDN[i] = TrendDN[i+1];
         }
      }
      else
      if (Line1[i]< Line2[i]) {
         if (diffP > treshold) {
            TrendUP[i] = EMPTY_VALUE;
            TrendDN[i] = 0;
         }
         else{
            TrendUP[i] = TrendUP[i+1];
            TrendDN[i] = TrendDN[i+1];  
         }
      }

            HistoTr[i] = EMPTY_VALUE;     HistoRetr[i]= EMPTY_VALUE;

      //-- long trend
      if (Line1[i] > 0 && TrendUP[i] == 0) {
         if (High[i] <= High[i+1]) {
            HistoRetr[i] = Line1[i];
            HistoTr[i] = EMPTY_VALUE;
         }
         else {
            HistoRetr[i]= EMPTY_VALUE;
            HistoTr[i] = Line1[i];
         }
      }
      else
      //-- short trend
      if (Line1[i] < 0 && TrendDN[i] == 0) {
         if (Low[i] >= Low[i+1]) {
            HistoRetr[i]= Line1[i]; 
            HistoTr[i] = EMPTY_VALUE;
         }
         else {
            HistoRetr[i]= EMPTY_VALUE;
            HistoTr[i] = Line1[i];
         }
      }
   }
   return(0);
}

//+------------------------------------------------------------------+ 
//|      WMA
//+------------------------------------------------------------------+ 

